/** Fichier station.c **/

/******************************************************************/
/** Serveur pour la station de pollution                         **/
/******************************************************************/

/** Fichiers d'inclusion **/
#include <getopt.h>
#include "libcom.h"
#include "libthrd.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <poll.h>
/** Constantes **/
#define MAX_LIGNE 2048
#define MAX_TAMPON 1024
#define MAX_UDP_MESSAGE 256


/** Variables publiques **/

/** Variables statiques **/

/** Procedure principale **/

//int s=3;
int adresse=0;

void EnvoiFichier(char * chemin,FILE * dialogue)
{
	FILE * monFichier;
	monFichier = fopen(chemin, "r");
	long Taille;
	char * buffer;
	size_t Traitement;
	char entete[50]="HTTP/1.1 200 OK\n\n";

	fseek (monFichier , 0 , SEEK_END);
	Taille = ftell (monFichier);
	rewind (monFichier);

	// allocate memory to contain the whole file:
	buffer = (char*) malloc (sizeof(char)*Taille);
	if (buffer == NULL) {fputs ("http:Probleme mémoire (malloc)",stderr); exit (2);}

	// copy the file into the buffer:
	Traitement = fread (buffer,1,Taille,monFichier);
	if (Traitement != Taille) {fputs ("http: Probleme lecture fichier",stderr); exit (3);}
	fprintf(dialogue,"%s",entete);
	fwrite(buffer,1,Taille,dialogue);
	fclose (monFichier);
	free (buffer);

}
int VerifLogin(char * arg1,char * arg2,int login_ok)
{
	FILE * monFichier=NULL;
	monFichier = fopen("LOGIN.txt", "r");
	char login[MAX_LIGNE]="";
	if (monFichier != NULL)
    {	
		strcat(arg1,"\n");
        while (fgets(login, MAX_LIGNE, monFichier) != NULL) // On lit le fichier tant qu'on ne reçoit pas d'erreur (NULL)
        {
            //printf("%s", login); // On affiche la chaîne qu'on vient de lire
			if (strcmp(arg1,login) == 0)
			{
				login_ok=1;
			}
        }
		
        fclose(monFichier);
		return login_ok;
    }
    else
    {
        // On affiche un message d'erreur si on veut
        printf("Impossible d'ouvrir le fichier test.txt");
    }

	fclose (monFichier);
	
	return 0;
}
// int Gestion_tag(char *tag,int val_tag)
// {
// 	printf("tag: %s\n",tag);
// 	if (strcmp(tag, "A001") == 0) 
// 	{
// 		printf("aaaaaaaaaaaaaatag: %s\n",tag);
// 		val_tag=1;
// 		printf("aaaaaaaaaaaaaatag: %d\n",val_tag);
// 	} 
// 	else if (strcmp(tag, "A002") == 0)
// 	{
// 		val_tag=2;
// 	}
// 	else if (strcmp(tag, "A003") == 0)
// 	{
// 		val_tag=3;
// 	}
// 	else if (strcmp(tag, "A004") == 0)
// 	{
// 		val_tag=4;
// 	}
// 	else if (strcmp(tag, "A005") == 0)
// 	{
// 		val_tag=5;
// 	}
// 	else
// 	{
// 		val_tag=999;
// 	}
		
// return val_tag;
// }


int gestionClientTCP(int s)
{
	//int s=*(int *)arg;
	/* Obtient une structure de fichier */
	FILE *dialogue=fdopen(s,"a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if(dialogue==NULL){ perror("gestionClientTCP.fdopen"); exit(EXIT_FAILURE); }

	/* Echo */
	char ligne[MAX_LIGNE];
	char tag[MAX_LIGNE],fct[MAX_LIGNE],arg1[MAX_LIGNE],arg2[MAX_LIGNE];
	char buffer[MAX_LIGNE]="OK IMAP2 Server Ready \n\r";
	char reponse_log1[MAX_LIGNE]="LOGIN_OK\n";
	char reponse_log2[MAX_LIGNE]="LOGIN_ERROR\n";
	char reponse_log3[MAX_LIGNE]="FONCTION_ERROR\n";
	char reponse_log4[MAX_LIGNE]="BYE LOGOUT\n";
	//int val_tag;
	int login_ok=0;

	fwrite(buffer,1,sizeof(buffer),dialogue);

	while(fgets(ligne,MAX_LIGNE,dialogue) !=NULL)//while(fgets(ligne,MAX_LIGNE,dialogue)) //while(fgets(ligne,MAX_LIGNE,dialogue) !=NULL && strlen(ligne) < 3)
	{	
		sscanf(ligne,"%s %s %s %s",tag,fct,arg1,arg2 );//a finir
		//printf("tag: %s fct: %s arg1: %s arg2: %s \n",tag,fct,arg1,arg2 );
		//printf("ligne=%s\n",ligne);

		//val_tag=Gestion_tag(tag,val_tag);

		if ((strcmp(tag, "A001") == 0) || (strcmp(tag, "1") == 0))
		{
			if (strcmp(fct, "LOGIN") == 0)
			{
				printf("A001 OK\n");
			login_ok=VerifLogin(arg1,arg2,login_ok);
			if (login_ok==1)
				{
					fwrite(reponse_log1,1,sizeof(reponse_log1),dialogue);
					login_ok=0;
					while (1)
					{
						fgets(ligne,MAX_LIGNE,dialogue);
						sscanf(ligne,"%s %s %s %s",tag,fct,arg1,arg2 );
						if ((strcmp(tag, "A007") == 0)|| (strcmp(tag, "7") == 0))
						{
							printf("BYEBYE \n");
							fwrite(reponse_log4,1,sizeof(reponse_log4),dialogue);
							break;
						}
					}
				}
				else
				{
					fwrite(reponse_log2,1,sizeof(reponse_log2),dialogue);
				}
			}
			else
			{
				fwrite(reponse_log3,1,sizeof(reponse_log3),dialogue);
			}
			

			
			
		} 
		else if ((strcmp(tag, "A002") == 0) || (strcmp(tag, "2") == 0))
		{
			printf("A002 OK\n");
		}
		else if ((strcmp(tag, "A003") == 0) || (strcmp(tag, "3") == 0))
		{
			printf("A003 OK\n");
		}
		else if ((strcmp(tag, "A004") == 0) || (strcmp(tag, "4") == 0))
		{
			printf("A004 OK\n");
		}
		else if ((strcmp(tag, "A005") == 0) || (strcmp(tag, "5") == 0))
		{
			printf("A005 OK\n");
		}
		else
		{
			printf("************ ERROR ************\n");
		}

	}
	


	/* Termine la connexion */
	fclose(dialogue);
	printf("client déconnecté\n");
	return 0;
}


// int multi_gestionClientTCP(int s)
// {
// 	//int dialogue= s;
// 	lanceThread(gestionClientTCP,(int) s,0);
// 	return 0;
// }





void serveur_TCP(void)
{
	int s=0;
	//   /* Lecture des arguments de la commande */
	//   //analyseArguments(argc,argv[0]); // à améliorer


	//char * machine = argv[0];
	//char *port= argv[1]; 
	//char *machine="localhost"; // equivalent de 127.0.0.1
	char *port="993"; // faire attention à ne pas choisir un port utilisé par le système
	int connexions= 6; //maximum 6 clients dans la file d'attente TCP


	/* Initialisation du serveur */
	s=initialisationServeurTCP(port,connexions);

	/* Lancement de la boucle d'ecoute */
	//boucleServeurTCP(s,gestionClientTCP);
	boucleServeurTCP(s,gestionClientTCP);


	/* On termine la connexion */
	shutdown(s,SHUT_RDWR);
	/* PARTIE UDP EN COMMENTAIRE CAR DOIT ETRE EXECUTEE EN PARALELLE */


}

int main(int argc,char *argv[])
{


	//struct addrinfo *addr_broadcast;

	/*--------------- fin partie UDP -------------------------------*/

	serveur_TCP();
	//serveur_UDP();

	return 0;
}
